// ++
//      History Downloader Expert                                          HistoryDownloader.mq4 
//          .                                     
//       s-Downloader (http://codebase.mql4.com/ru/5875)    
//  Talex.                                                                                       
//      s-Downloader:      ,   
//     .                                                                
//      :                                                      
//        ;                                                               
//          .  ;                                     
//          HistoryDownloaderI.                                      
//         Bars,  - Time[].    
//  ,          start(),  ,    
//        .  ,        
//       .    .  
// ----------------------------------------------------------------------------------------------
//      [release 1] 23.08.2009                                                                   
//   .       ;)                     
//                                                             |  xp3rienced, Ekaterinburg 2009 
// ++
#property copyright " xp3rienced"
#property link      "no4ta[at]inbox.ru"

#import "user32.dll"
  int PostMessageA (int hWnd, int Msg, int wParam, int lParam);
#import

#define PAUSE_ON_UPDWAIT 0
#define KEYPRESS_REPEATS 2
#define WM_KEYDOWN 0x0100
#define WM_KEYUP 0x0101
#define VK_HOME 0x24
#define GVNAME_BAR_COUNT "BarOnChartCount"
#define GVNAME_FIRST_BAR_TIME "FirstBarDateTime"
#define DELIMITER_STR "\n"
#define ERRSTR_CANT_RECV_HWND "     (HWND) .\n "
#define ERRSTR_CANT_FIND_GV "   . ,     .\n "
#define ERRSTR_SUCCESS "   .\n ,   ,   ,     \n( ,   ,        )\n"
#define ERRSTR_FAIL "   .\n,    ,      \n  ,       \n"

//====[   ]====
extern string d1 = " . ..     ";
extern datetime ToDate = D'01.01.2009';
extern string d2 = "  ().    ,     ,      ";
extern int Timeout = 1000;
extern string d3 = "     .      ,   ";
extern int MaxFailsInARow = 10;

//====[   ]====
string CurrSymbol;                      //   
int CurrPeriod;                         //   
int ChartHWND;                          //   
int BarsAtStart;                        //    ,  
int ExecStartTime;                      //    
int LastLatency;                        //    
string ErrorString;

//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
int init()
{
//----
  CurrSymbol = Symbol();
  CurrPeriod = Period();
  ErrorString = "";
  GetLastError();           //   last_error
  ChartHWND = WindowHandle(CurrSymbol, CurrPeriod);
  if(ChartHWND == 0)
    ErrorString = StringConcatenate(ERRSTR_CANT_RECV_HWND, "\n : ", GetLastError(), "\n");
  if(!GlobalVariableCheck(GVNAME_BAR_COUNT) || !GlobalVariableCheck(GVNAME_FIRST_BAR_TIME))
    ErrorString = StringConcatenate(ErrorString, ERRSTR_CANT_FIND_GV);
  if(ErrorString != "")
  {
    Alert(ErrorString);
    return(0);
  }
  BarsAtStart = Bars;
  ExecStartTime = GetTickCount();
  start();                  // ,    :)      
//----
  return(0);
}

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int deinit()
{
//----
  UnpressHOME();            // (?)  - ,   
//----
  return(0);
}

//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
int start()
{
  if(ErrorString != "") return(0);
//----
  bool success = DownloadHistory(ToDate);
  string s = StringConcatenate(DELIMITER_STR,
    " : ", WindowFirstVisibleBar() - BarsAtStart + 1,
    "\n : ", FormatTime(GetTickCount() - ExecStartTime)
  );
  if(success) s = StringConcatenate(ERRSTR_SUCCESS, s);
  else s = StringConcatenate(ERRSTR_FAIL, s);
  Alert(s);
//----
  return(0);
}
//+-----------------    -----------------+

//+------------------------------------------------------------------+
//|                                    |
//|      HOME       |
//| ,    .         |
//|   ,  ,        |
//+------------------------------------------------------------------+
bool DownloadHistory(datetime EndTime)
{
  int FailCount = 0;                                          //   ,  
  datetime FirstBarTime;
  while(!IsStopped())
  {
    PressHOME();                                              //    HOME
    if(WaitForChartUpdate())                                  //   
      FailCount = 0;                                          //    -   
    else FailCount++;                                         // ,   
    UnpressHOME();                                            //  HOME
    FirstBarTime = GlobalVariableGet(GVNAME_FIRST_BAR_TIME);
    Comment(StringConcatenate("    ", TimeToStr(EndTime), "\n  : ",
      TimeToStr(FirstBarTime), "\n  : ", GlobalVariableGet(GVNAME_BAR_COUNT),
      "\n   : ", LastLatency, "\n   : ",
      FormatTime(GetTickCount() - ExecStartTime)));
    if(FirstBarTime <= EndTime) return(true);
    if(FailCount >= MaxFailsInARow) return(false);
  }
}

//+------------------------------------------------------------------+
//|                                    |
//|        .   |
//|  : true -   ( );  |
//| false -   ,   .         |
//| ,  - ,    (?)  |
//|   PAUSE_ON_UPD_WAIT,         |
//|                                       |
//+------------------------------------------------------------------+
bool WaitForChartUpdate()
{
  int FirstVisBar = WindowFirstVisibleBar();
  int Start = GetTickCount();
  while(true)
  {
    if(WindowFirstVisibleBar() > FirstVisBar) return(true);
    LastLatency = GetTickCount() - Start;                     //     
    if(LastLatency >= Timeout) return(false);
    Sleep(PAUSE_ON_UPDWAIT);
  }
}

//+------------------------------------------------------------------+
//|                  HOME               |
//|    WM-  .       |
//|  KEYPRESS_REPEATS        |
//|  .  : 0..255                       |
//+------------------------------------------------------------------+
void PressHOME()
{
  PostMessageA(ChartHWND, WM_KEYDOWN, VK_HOME, KEYPRESS_REPEATS);
}

//+------------------------------------------------------------------+
//|                  HOME               |
//|    WM-  .       |
//+------------------------------------------------------------------+
void UnpressHOME()
{
  PostMessageA(ChartHWND, WM_KEYUP, VK_HOME, 1);
}

//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
string FormatTime(int milliseconds)
{
  int seconds = milliseconds / 1000;
  return(StringConcatenate(TimeHour(seconds), " ", TimeMinute(seconds), " ", TimeSeconds(seconds), ""));
}
//+------------------------------------------------------------------+